<?php

	// static variables declaration
	$ipp = 16; // items per page
	$page_num = 1;
	$pages_mid_range = 5;
	$order = 'name';
	$direction = 'asc';

	if (isset($_GET['ipp']) && $_GET['ipp'] != '') {
		$ipp = $_GET['ipp'];
	}
	if (isset($_GET['page']) && $_GET['page'] != '') {
		$page_num = $_GET['page'];
	}
	if (isset($_GET['order']) && $_GET['order'] != '') {
		$order = $_GET['order'];
	}
	if (isset($_GET['dir']) && $_GET['dir'] != '') {
		$direction = $_GET['dir'];
	}
	// static variables declaration
	
	// Path to Magento
	require_once('../app/Mage.php'); 
	require_once('../scripts/paginator.class.2.php'); 
	umask(0);
	Mage::app();
	
	$baseurl = Mage::app()->getStore()->getBaseUrl(); 
	$main_domain = Mage::getStoreConfig('general/store_information/name');
	
	//fetch subdomain information
	// fetch write database connection that is used in Mage_Core module
	$write = Mage::getSingleton('core/resource')->getConnection('core_write');
	
	// now $write is an instance of Zend_Db_Adapter_Abstract
	$readresult = $write->query("select * from subdomain_category where subdomain_name = '".$_SERVER['HTTP_HOST']."'");
	
	while ($row = $readresult->fetch() ) {
		$category_level = $row['subdomain_category_level'];
		$category_id = $row['subdomain_category_id'];
	}
	//fetch subdomain information
	
	// Load the session so we get quotes.
	Mage::getSingleton('core/session', array('name' => 'frontend'))->start();
	Mage::getDesign()->setTheme('parisjewel');
	
	$layout = Mage::getSingleton('core/layout');
	$layout->getUpdate()->addHandle('default');
	
	// head block
	$headBlock = $layout->createBlock('page/html_head');
	
	// add JS
	$headBlock->addJs('prototype/prototype.js');
	$headBlock->addJs('lib/ccard.js');
	$headBlock->addJs('prototype/validation.js');
	$headBlock->addJs('scriptaculous/builder.js');
	$headBlock->addJs('scriptaculous/effects.js');
	$headBlock->addJs('scriptaculous/dragdrop.js');
	$headBlock->addJs('scriptaculous/controls.js');
	$headBlock->addJs('scriptaculous/slider.js');
	$headBlock->addJs('varien/js.js');
	$headBlock->addJs('varien/form.js');
	$headBlock->addJs('varien/menu.js');
	$headBlock->addJs('mage/translate.js');
	$headBlock->addJs('mage/cookies.js');
	
	// add CSS
	$headBlock->addCss('css/styles.css');
	$headBlock->addCss('css/template.css');
	$headBlock->addCss('css/navigation.css');
	$headBlock->addCss('css/widgets.css');
	$headBlock->addCss('css/print.css', 'media=print');
	
	$headBlock->getCssJsHtml();
	$headBlock->getIncludes();
	
	// header block
	$headerBlock = $layout->createBlock('page/html_header')->setTemplate('page/html/header.phtml');
	$linksBlock = $layout->createBlock('page/template_links')->setTemplate('page/template/links.phtml');
	$linksBlock->addLink('My Account',$baseurl.'customer/account/','My Account','','',10);
	$linksBlock->addLink('My Cart',$baseurl.'checkout/cart/','My Cart','','',10);
	$linksBlock->addLink('Checkout',$baseurl.'checkout/','Checkout','','',10);
	$linksBlock->addLink('Login',$baseurl.'customer/account/login/','Login','','',10);
	$headerBlock->setChild('topLinks',$linksBlock);
	$headerBlock = $headerBlock->toHtml();
	
	// menu block
	$topmenuBlock = $layout->createBlock('catalog/navigation')->setTemplate('catalog/navigation/top.phtml')->toHtml();
	
	// search block
	$searchBlock = $layout->createBlock('catalogsearch/advanced_form')->setTemplate('catalogsearch/advanced/form.phtml')->toHtml();

	// footer block
	$newsletterBlock = $layout->createBlock('newsletter/subscribe')->setTemplate('newsletter/subscribe.phtml');
	$footerBlock = $layout->createBlock('catalog/navigation')->setTemplate('page/html/footer.phtml');
	$footerBlock->setChild('newsletter',$newsletterBlock);
	$footerBlock = $footerBlock->toHtml();
	
	// load collection
	$category_collection = Mage::getModel('catalog/category')->load($category_id); //category object
	$product_collection = Mage::getModel('catalog/product')->getCollection()->addCategoryFilter($category_collection)
								->addAttributeToFilter('status', array('eq' => 1))
								->joinField('qty','cataloginventory/stock_item','qty','product_id=entity_id','{{table}}.stock_id=1','left')
								->addAttributeToFilter('qty', array('gt' => 0)) // current page and limit
								->addAttributeToSort($order, $direction) // position, name or price
								->setPageSize($ipp) // limit
								->setPage($page_num, $ipp);
	
	if (isset($_GET['name']) && $_GET['name'] != '') {
		$product_collection->addAttributeToFilter('name', array('like' => '%'.$_GET['name'].'%'));
	}
	
	if (isset($_GET['sku']) && $_GET['sku'] != '') {
		$product_collection->addAttributeToFilter('sku', array('eq' => $_GET['sku']));
	}
	
	if (isset($_GET['price']['from']) && $_GET['price']['from'] != '') {
		$product_collection->addFieldToFilter(array(array('attribute'=>'special_price','gteq'=>$_GET['price']['from'])));
	}
	if (isset($_GET['price']['to']) && $_GET['price']['to'] != '') {
		$product_collection->addFieldToFilter(array(array('attribute'=>'special_price','lteq'=>$_GET['price']['to'])));
	}
	if (!isset($_GET['price']['from']) && $_GET['price']['from'] == '' && !isset($_GET['price']['to']) && $_GET['price']['to'] == '') {
		$product_collection->addFieldToFilter(array(array('attribute'=>'special_price','gt'=>'0')));
	}
	
	if (isset($_GET['special_price']['from']) && $_GET['special_price']['from'] != '') {
		$product_collection->addFieldToFilter(array(array('attribute'=>'special_price','gteq'=>$_GET['special_price']['from'])));
	}
	if (isset($_GET['special_price']['to']) && $_GET['special_price']['to'] != '') {
		$product_collection->addFieldToFilter(array(array('attribute'=>'special_price','lteq'=>$_GET['special_price']['to'])));
	}
	if (!isset($_GET['special_price']['from']) && $_GET['special_price']['from'] == '' && !isset($_GET['special_price']['to']) && $_GET['special_price']['to'] == '') {
		$product_collection->addFieldToFilter(array(array('attribute'=>'special_price','gt'=>'0')));
	}
	
	if (isset($_GET['manufacturer']) && $_GET['manufacturer'] != '') {
		$product_collection->addAttributeToFilter('manufacturer', array('like' => '%'.$_GET['manufacturer'].'%'));
	}
	
	//echo $category_collection->getselect();
	$product_collection->load();
	
	// load paging
	$total_products = $product_collection->getSize();
	
	$pages = new Paginator();
	$pages->items_per_page = $ipp;
	$pages->mid_range = $pages_mid_range;
	$pages->items_total = $total_products;
	$pages->paginate();
	
	$start_range = ($page_num == 1 ? 1 : $ipp * ($page_num-1)+1);
	$end_range = ($total_products < $page_num * $ipp ? $total_products : $page_num * $ipp);
	$display_items_total = "Items ".$start_range." to ".$end_range." of ".$total_products." total";
	
	// decide category / sub category
	if ($category_level == 0) {
		$category_detail = Mage::getModel('catalog/category')->load($category_id);
		$category_name = $category_detail->getName();
		
		$sub_categories = $category_detail->getChildren();
		
		$i = 0;
		$sub_category_list = array();
		foreach(explode(',',$sub_categories) as $sub_category_id)
		{
			$_category = Mage::getModel('catalog/category')->load($sub_category_id);
			if($_category->getIsActive())
			{
				$sub_category_list[$i]['name'] = $_category->getName();
				$sub_category_list[$i]['domain'] = str_replace(" ", "-", strtolower($_category->getName()));
				$i++;
			}
		}
		
		$breadcrumb_name_display = $category_name;
		$category_name_display = $category_name;
		$meta_name_display = $category_name;
	}
	else{
		$parent_category_id = Mage::getModel('catalog/category')->load($category_id)->getParentId();
		
		$category_detail = Mage::getModel('catalog/category')->load($parent_category_id);
		$category_name = $category_detail->getName();
		
		$sub_category_detail = Mage::getModel('catalog/category')->load($category_id);
		$sub_category_name = $sub_category_detail->getName();
		
		$category_name_url = "http://".str_replace(" ", "-", strtolower($category_name)).".".$main_domain;
		$category_name_display = '<strong><a href="'.$category_name_url.'">'.$category_name. '</a></strong> > '.$sub_category_name;
		$sub_category_list = array();
		
		$breadcrumb_name_display = $category_name_display;
		$category_name_display = $sub_category_name;
		$meta_name_display = $category_name . " > " . $sub_category_name;
	}
	
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	<title><?php echo $meta_name_display; ?></title>
	<meta name="description" content="<?php echo $meta_name_display; ?>" />
	<meta name="keywords" content="<?php echo $meta_name_display; ?>" />
	<meta name="robots" content="*" />
	<link rel="icon" href="<?php echo $baseurl; ?>/skin/frontend/default/parisjewel/favicon.ico" type="image/x-icon" />
	<link rel="shortcut icon" href="<?php echo $baseurl; ?>/skin/frontend/default/parisjewel/favicon.ico" type="image/x-icon" />
	<!--[if lt IE 7]>
	<script type="text/javascript">
	//<![CDATA[
		var BLANK_URL = '<?php echo $baseurl; ?>js/blank.html';
		var BLANK_IMG = '<?php echo $baseurl; ?>js/spacer.gif';
	//]]>
	</script>
	<![endif]-->
	
	<?php echo $headBlock->getCssJsHtml(); ?>
	<?php echo $headBlock->getIncludes(); ?>
	
	<!--[if lt IE 8]>
	<link rel="stylesheet" type="text/css" href="<?php echo $baseurl; ?>/skin/frontend/default/parisjewel/css/styles-ie.css" media="all" />
	<![endif]-->
	<!--[if lt IE 7]>
	<script type="text/javascript" src="<?php echo $baseurl; ?>/js/lib/ds-sleight.js"></script>
	<script type="text/javascript" src="<?php echo $baseurl; ?>/skin/frontend/base/default/js/ie6.js"></script>
	<![endif]-->
	
	<script type="text/javascript">
	//<![CDATA[
	optionalZipCountries = ["HK","IE","MO","PA"];
	//]]>
	</script>
	
	<script type="text/javascript">var Translator = new Translate({"Please use only letters (a-z or A-Z), numbers (0-9) or underscore(_) in this field, first character should be a letter.":"Please use only letters (a-z or A-Z), numbers (0-9) or underscores (_) in this field, first character must be a letter."});</script>
</head>
<body>
<div class="wrapper">
	<noscript>
        <div class="noscript">
            <div class="noscript-inner">
                <p><strong>JavaScript seem to be disabled in your browser.</strong></p>
                <p>You must have JavaScript enabled in your browser to utilize the functionality of this website.</p>
            </div>
		</div>
    </noscript>
	
    <div class="page">
		<?php echo $headerBlock; ?>
	
		<?php echo $topmenuBlock; ?>

		
        <div class="main-container col2-left-layout">
            <div class="main">
                <div class="col-main">
					<div class="breadcrumbs">
						<ul>
							<li class="home"><a href="<?php echo $baseurl; ?>" title="Go to Home Page">Home</a><span> > </span></li>
							<li class="category3"><?php echo $breadcrumb_name_display; ?></li>
						</ul>
					</div>
					
                    <div class="page-title category-title">
				        <h1><?php echo $category_name_display; ?></h1>
						<span style="float:right; margin-top:-20px;"><a href="/?order=name&ipp=<?php echo $total_products; ?>&name=&sku=&price[from]=&price[to]=" >View All Items</a></span>
					</div>

					<?php 
					if ($pages->display_pages() != '') {
					?>
					<div class="category-products">
    					<form name="categoryFrm" id="categoryFrm" method="get">
						<div class="toolbar">
						
							<div class="sorter">
								<div class="pages">
									<p class="view-mode"><?php echo $display_items_total; ?></p>
								</div>
								<div class="sort-by">
									<strong>Page:</strong>
									<?php echo $pages->display_pages(); ?>
								</div>
							</div>
							
							<div class="sorter">
								<div class="sort-by">
									<label>Sort By</label>
									<select name="order" id="order" onchange="form.submit();">
										<option <?php if (isset($order) && $order == 'position') {?>selected="selected"<?php }; ?>value="position">Position</option>
										<option <?php if (isset($order) && $order == 'name') {?>selected="selected"<?php }; ?>value="name">Name</option>
										<option <?php if (isset($order) && $order == 'price') {?>selected="selected"<?php }; ?>value="price">Price</option>
									</select>
									<?php 
									$pageURL_arr = explode("&", $_SERVER["REQUEST_URI"]);
									$pageURL_arr_unique = array_unique($pageURL_arr);
									$pageURL = implode("&", $pageURL_arr_unique);

									if(substr_count($pageURL, "?") == 0)
									{
										$qs = "?";
									}
									else
									{
										$qs = "&";
									}
									?>
									<?php if($direction == 'desc'): ?>
										<a href="<?php echo $pageURL.$qs; ?>dir=asc" title="Set Ascending Direction"> <?php if (isset($order) && $order == 'price') {?>Low to High<?php } else {?> Ascending <?php }; ?> <img src="<?php echo Mage::getDesign()->getSkinUrl('images/i_desc_arrow.gif'); ?>" alt="Set Ascending Direction" class="v-middle" /></a>
									<?php else: ?>
										<a href="<?php echo $pageURL.$qs; ?>dir=desc" title="Set Descending Direction"> <?php if (isset($order) && $order == 'price') {?>High to Low<?php } else {?> Descending<?php }; ?> <img src="<?php echo Mage::getDesign()->getSkinUrl('images/i_asc_arrow.gif'); ?>" alt="Set Descending Direction" class="v-middle" /></a>
									<?php endif; ?>
								</div>
								<div class="limiter">
									<label>Show</label>
									<select name="ipp" id="ipp" onchange="form.submit();">
										<option <?php if (isset($_GET['ipp']) && $_GET['ipp'] == '16') {?>selected="selected"<?php }; ?> value="16">16</option>
										<option <?php if (isset($_GET['ipp']) && $_GET['ipp'] == '32') {?>selected="selected"<?php }; ?>value="32">32</option>
										<option <?php if (isset($_GET['ipp']) && $_GET['ipp'] == '64') {?>selected="selected"<?php }; ?>value="64">64</option>
									</select> per page        
								</div>
							</div>
							
						</div>
						</form>
						<?php
						
						$col_count = 1;
						foreach($product_collection as $product) {
						
							$product_id = $product->getId();
							$full_product = Mage::getModel('catalog/product')->load($product_id);
							
							$product_name = $full_product->getName();
							$product_url = $full_product->getProductUrl();
							$product_image_url = $full_product->getImageUrl();
							
							$product_price = number_format($full_product->getPrice(), 2);
							$product_special_price = number_format($full_product->getSpecialPrice(), 2);
							
							if ($col_count == 1)
							{
								?>
                                <ul class="products-grid"> 
                                <?php
							}
							
							if ($col_count == 1)
							{
								$class = ' first';
							}
							else if ($col_count == 4)
							{
								$class = ' last';								
							}
							else
							{
								$class = '';
							}
							?>
                            
							<li class="item<?php echo $class; ?>">
								<a href="<?php echo $product_url; ?>" title="<?php echo $product_name; ?>" class="product-image"><img src="<?php echo $product_image_url; ?>" width="170" height="170" alt="<?php echo $product_name; ?>" /></a>
								<h2 class="product-name"><a href="<?php echo $product_url; ?>" title="<?php echo $product_name; ?>"><?php echo $product_name; ?></a></h2>
							   <div class="price-box">
									<p class="old-price">
										<span class="price-label">Regular Price:</span>
										<span class="price" id="old-price-1">$<?php echo $product_price; ?></span>
									</p>
				
									<p class="special-price">
										<span class="price-label">Special Price:</span>
										<span class="price" id="product-price-1">$<?php echo $product_special_price; ?></span>
									</p>
								</div>
							</li>
							<?php
							
							$col_count++;
							
							if ($col_count == 5)
							{
								$col_count = 1;
								
							}
							
							if ($col_count == 1)
							{
								?>
                                </ul>
                                <?php
							}
						}
						
						if($total_products % 4 != 0)
						{
							?>
							</ul>
							<?php
						}
						?>    
						<form name="categoryFrm2" id="categoryFrm2" method="get">
						<div class="toolbar">
						
							<div class="sorter">
								<div class="pages">
									<p class="view-mode"><?php echo $display_items_total; ?></p>
								</div>
								<div class="sort-by">
									<strong>Page:</strong>
									<?php echo $pages->display_pages(); ?>
								</div>
							</div>
							
							<div class="sorter">
								<div class="sort-by">
									<label>Sort By</label>
									<select name="order" id="order" onchange="form.submit();">
										<option <?php if (isset($order) && $order == 'position') {?>selected="selected"<?php }; ?>value="position">Position</option>
										<option <?php if (isset($order) && $order == 'name') {?>selected="selected"<?php }; ?>value="name">Name</option>
										<option <?php if (isset($order) && $order == 'price') {?>selected="selected"<?php }; ?>value="price">Price</option>
									</select>
									<?php 
									$pageURL_arr = explode("&", $_SERVER["REQUEST_URI"]);
									$pageURL_arr_unique = array_unique($pageURL_arr);
									$pageURL = implode("&", $pageURL_arr_unique);

									if(substr_count($pageURL, "?") == 0)
									{
										$qs = "?";
									}
									else
									{
										$qs = "&";
									}
									?>
									<?php if($direction == 'desc'): ?>
										<a href="<?php echo $pageURL.$qs; ?>dir=asc" title="Set Ascending Direction"> <?php if (isset($order) && $order == 'price') {?>Low to High<?php } else {?> Ascending <?php }; ?> <img src="<?php echo Mage::getDesign()->getSkinUrl('images/i_desc_arrow.gif'); ?>" alt="Set Ascending Direction" class="v-middle" /></a>
									<?php else: ?>
										<a href="<?php echo $pageURL.$qs; ?>dir=desc" title="Set Descending Direction"> <?php if (isset($order) && $order == 'price') {?>High to Low<?php } else {?> Descending<?php }; ?> <img src="<?php echo Mage::getDesign()->getSkinUrl('images/i_asc_arrow.gif'); ?>" alt="Set Descending Direction" class="v-middle" /></a>
									<?php endif; ?>
								</div>
								<div class="limiter">
									<label>Show</label>
									<select name="ipp" id="ipp" onchange="form.submit();">
										<option <?php if (isset($_GET['ipp']) && $_GET['ipp'] == '16') {?>selected="selected"<?php }; ?> value="16">16</option>
										<option <?php if (isset($_GET['ipp']) && $_GET['ipp'] == '32') {?>selected="selected"<?php }; ?>value="32">32</option>
										<option <?php if (isset($_GET['ipp']) && $_GET['ipp'] == '64') {?>selected="selected"<?php }; ?>value="64">64</option>
									</select> per page        
								</div>
							</div>
							
						</div>
						</form>
					</div>
					<?php
					}
					else {
						?>
						<div>There are no product found for this keyword.</div>
						<?php
					}
				?>
				
				</div>
				
				<div class="col-left sidebar">
					<form name="categoryFrm" id="categoryFrm" method="get">
					<?php echo $searchBlock; ?>
					<?php
					if (count($sub_category_list)>0) {
						?>
						<div class="block block-layered-nav">
							<div class="block-content">
								<p class="block-subtitle">Browse ParisJewelry</p>
								<dl id="narrow-by-list">
									<!--<dt>Category</dt>-->
									<dd>
										<ol>
										<?php
										for($j=0; $j<count($sub_category_list); $j++)
										{
											?>
											<li><a href="http://<?php echo $sub_category_list[$j]['domain'].".".$main_domain; ?>"><?php echo $sub_category_list[$j]['name']; ?></a></li>
											<?php
										}
										?>
										</ol>
									</dd>
								</dl>
							</div>
						</div>
						<?php
					}
					?>
					
					<div>
						<?php
							Mage::register('current_category', $category_collection);
							$leftBlock = $layout->createBlock('catalog/layer_view')->setTemplate('catalog/layer/view.phtml')->toHtml();
							echo $leftBlock;
						?>
					</div>
										
					<div align="center">
						<img src="<?php echo Mage::getDesign()->getSkinUrl('images/free_shipping_banner.gif'); ?>" border="0" />
					</div>
					</form>
				</div>

			</div>

		</div>
      
		
		<br clear="all" />

		<?php echo $footerBlock; ?>
	
	</div>
</div>
</body>
</html>
